package com.dzeio.openhealth.data.weight

import androidx.room.ColumnInfo
import androidx.room.Entity
import androidx.room.PrimaryKey
import java.sql.Date
import java.text.DateFormat.getDateInstance
import java.util.*

@Entity()
data class Water(
    @PrimaryKey(autoGenerate = true) var id: Long = 0,
    var value: Int = 0,
    @ColumnInfo(index = true)
    var timestamp: Long = System.currentTimeMillis(),
    var source: String = "OpenHealth"
) {
    init {
        val cal = Calendar.getInstance()
        cal.set(Calendar.HOUR_OF_DAY, 0)
        cal.set(Calendar.MINUTE, 0)
        cal.set(Calendar.SECOND, 0)
        cal.set(Calendar.MILLISECOND, 0)

        timestamp = cal.timeInMillis
    }

    fun formatTimestamp(): String = getDateInstance().format(Date(timestamp))
}