package com.dzeio.openhealth.data.weight

import androidx.room.*
import com.dzeio.openhealth.core.BaseDao
import dagger.Provides
import kotlinx.coroutines.flow.Flow

@Dao
interface WaterDao : BaseDao<Water> {

    @Query("SELECT * FROM Water")
    fun getAll(): Flow<List<Water>>

    @Query("SELECT * FROM Water where id = :weightId")
    fun getOne(weightId: Long): Flow<Water?>


    @Query("Select count(*) from Water")
    fun getCount(): Flow<Int>

    @Query("Select * FROM Water WHERE id=(SELECT max(id) FROM Water)")
    fun last(): Flow<Water?>

    @Query("DELETE FROM Water where source = :source")
    suspend fun deleteFromSource(source: String)
}