package com.dzeio.openhealth.data.weight

import android.util.Log
import kotlinx.coroutines.flow.*
import java.util.*
import javax.inject.Inject
import javax.inject.Singleton

@Singleton
class WaterRepository @Inject constructor(
    private val waterDao: WaterDao
) {
    fun getWaters() = waterDao.getAll()

    fun lastWater() = waterDao.last()

    fun getWater(id: Long) = waterDao.getOne(id)

    suspend fun addWater(value: Water) = waterDao.insert(value)
    suspend fun deleteWater(value: Water) = waterDao.delete(value)
    suspend fun deleteFromSource(value: String) = waterDao.deleteFromSource(value)

    fun todayWater() = lastWater().filter {
        val cal = Calendar.getInstance()
        cal.set(Calendar.HOUR_OF_DAY, 0)
        cal.set(Calendar.MINUTE, 0)
        cal.set(Calendar.SECOND, 0)
        cal.set(Calendar.MILLISECOND, 0)
        Log.d("WaterRepository", "${it?.timestamp} ${cal.timeInMillis}")
        return@filter it?.timestamp == cal.timeInMillis
    }
}