package com.dzeio.openhealth.extensions

import android.app.Activity
import android.content.Intent
import com.dzeio.openhealth.data.weight.Weight

abstract class Extension {

    enum class Data {
        WEIGHT,
        STEPS
    }

    abstract val sourceID: String

    open fun init(activity: Activity): Array<Data> = arrayOf()

    /**
     * Same as Activity/Fragment onRequestPermissionResult
     *
     * But it will only be launched if grantResults[0] == PackageManager.PERMISSION_GRANTED
     */
    open fun onRequestPermissionResult(requestCode: Int, permission: Array<String>, grantResult: IntArray) {}

    /**
     * Same as Activity/Fragment onActivityResult
     */
    open fun onActivityResult(requestCode: Int, resultCode: Int, data: Intent?) {}

    open fun <T> import(data: Data, cb: (item: T, end: Boolean) -> Unit) {}

    open fun importWeight(callback: (weight: Weight, end: Boolean) -> Unit) {}
}